<template>
  <div>
    <!-- Cuerpo -->
    <div style="margin: 0 4rem" class="padding-top">
      <el-header style="height: auto; margin: 0 2.75rem;">
        <el-row :gutter="15">
          <!-- Filtros -->
          <el-col :span="20" :offset="5">
            <el-col :span="9">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="11">
              <el-input
                class="input-head"
                placeholder="Buscar"
                prefix-icon="el-icon-search"
                v-model="textSearch"
                @clear="cleanSearch"
                @keyup.enter.native="filterMaterials"
                clearable
              ></el-input>
            </el-col>
            <el-col :span="2">
              <el-button @click="filterMaterials" type="primary" :disabled="textSearch==''">BUSCAR</el-button>
            </el-col>
          </el-col>
        </el-row>

        <!-- Subtítulo -->
        <el-col :span="24">
          <div class="titleSection">Lista de Materiales</div>
        </el-col>

        <!-- Botón nuevo -->
        <div class="text-end" style="margin-top: 3rem">
          <el-button @click="goToNewMaterial" type="primary">NUEVO MATERIAL</el-button>
        </div>
      </el-header>
      <div v-loading="loading" :element-loading-text="loadingText">
        <!-- Tarjetas -->
        <el-row
          v-bind:class="[ materials.length == 0 ? 'remove-grid-container' : 'grid-container' ]"
          v-if="materials && materials.length"
        >
          <el-col
            v-for="(material, index) in materials"
            style="margin-bottom: 4rem"
            :key="material.__id"
          >
          <!-- :emission="material.emissions" -->
            <app-cards
              :principalTitle="material.originalTitle"
              :dataTable="materials[index].validityString"
              :showvalidity="true"
              :showWindow="true"
              :textModal="textModal"
              :uniqueId="material.__id"
              :item="material"
              :editRoute="editRoute"
              @executeEdit="editMaterial($event, material)"
              @executeChangeStatus="statusChange(material)"
              :showSeason="material.numChapters"
              :positionSeason="'bottom'"
              :showAmounts="(material.stringMaterialType).search('Afiliación') == -1"
              :infoToShow="{
                0:{title: 'Cod. de Material:', content: material.codMaterial},
                1:{title: 'Cod. de Géminis:', content: material.geminisCode},
                2:{title: 'Cod. de Contrato:', 
                content: `${material.contractCode ? material.contractCode : ''} ${material.contractstatus && material.contractstatus === 'Cancelado' ? '(Contrato Cancelado)' : ''}`},

                3:{title: (material.numChapters.length > 0)?'Fecha de llegada - Cap. 1:':'Fecha de llegada:', content: getDateArrivaldate(material)},
              }"
              :principalData="{0:{ class: 'bg-orange-ligth text-white', subTitle: 'Precio Unitario', content: (material.unitPrice == 'Cortesía')?`${material.unitPrice}`: `${material.currencySymbol} ${material.unitPrice}`} }"
              :rowsInfo="{
                0: {
                  showDefault: true,
                  left: { subtitle: 'Proveedor', content: material.providerName},
                  right: { subtitle: 'Cod. de Proveedor', content: material.providerCode }
                },
                1:{
                  showDefault: true,
                  left: { subtitle: 'Tipo de Material', content: material.stringMaterialType},
                  right: { subtitle: 'Tipo de Contenido', content: material.typeOfContent },
                },
                2:{
                  showDefault: true,
                  left: { subtitle: 'Centro de Costo', content: material.costCenterName ? `${material.costCenter} -  ${material.costCenterName}` :  material.costCenterName || material.costCenter},
                  right: { subtitle: 'Canal de Transmisión', content: material.checkedChanels.join(', ')  }
                },
                3:{
                  showDefault: true,
                  left: { subtitle: 'Géneros', content: generos(material).length > 0 ? generos(material).toString().replace(/,/gi, ', ') : `Sin género asignado.` },
                  
                }
              }"
            />
          </el-col>
                <!-- :passSection=" {
                0: { hideAfiliado: (material.stringMaterialType).search('Afiliación') !== -1, passSubtitle: 'Precio por pasada', content: material.broadcastPrice.length > 0 ? `${material.currencySymbol} ${material.broadcastPrice[0]}` : 0 },
                1: { hideAfiliado: false, passSubtitle: 'Total de Pasadas', content: material.totalPass, passPrice: '' },
                2: { hideAfiliado: false, passSubtitle: 'Saldo de Pasadas', content: Number(material.totalPass) - Number(material.pasadasConsumidas), passPrice: '' }
              }" -->
        </el-row>
        <!-- Tarjeta 'No hay resultado' -->
        <el-row class="grid-container" v-else>
          <el-col v-if="isShowNoResults">
            <el-card :body-style="{ padding: '0px' }" class="bg-gray">
              <el-col :span="8" style="margin-top: 1rem" class="text-center">
                <img src="@/assets/images/detective.svg" alt />
              </el-col>
              <el-col :span="16">
                <div style="margin-top: 5rem">
                  <p class="title-styles">¡Lo sentimos!</p>
                  <p class="title-styles">{{existMaterial}}</p>
                </div>
              </el-col>
            </el-card>
          </el-col>
        </el-row>
      </div>
    </div>
  </div>
</template>

<script>
import Cards from '@/components/cards.vue'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { modifyText } from '@/utils/modifyText.js'
import { HTTP } from '@/main.js'
import { mapState } from 'vuex'

 /**
  * @vue-data {Array} listGenders - Lista de los generos
  * @vue-data {Array} allFilters - Filtros de busquedas de materiales
  * @vue-data {String} textSearch - Texto que hara el filtro
  * @vue-data {String} filterSelect - Tipo de filtro seleccionado
  * @vue-data {Array} allMaterials - Lista de todos los materiales
  * @vue-data {Array} searchMaterials - Lista de materiales filtrados
  * @vue-event {Array} generos - Retorna el nombre de todos los generos
  * @vue-computed {Array} materials - Lista de materiales filtrados o sin filtro
  */

export default {
  components: {
    'app-cards': Cards,
    'app-search-filter': SearchFilter,
    'app-select': Select,
  },
  data() {
    return {
      listGenders: [],
      textSearch: '',
      filterSelect: '',
      materialsInfo: [],
      allMaterials: [],
      searchMaterials: [],
      editRoute: 'newMaterial2',
      textModal: 'material',
      allFilters: [
        { value: 'codMaterial', label: 'Código Material' },
        { value: 'providerName', label: 'Nombre del Proveedor' },
        { value: 'providerCode', label: 'Código de Proveedor' },
        { value: 'startValidity', label: 'Vigencia - Inicio' },
        { value: 'endValidity', label: 'Vigencia - Fin' },
      ],
      loading: true,
      isShowNoResults: false,
      validHaveSupport: [],
      IsClick: false,
      existMaterial: 'No encontramos resultados para tu búsqueda',
    }
  },
  created() {
    this.getMaterials()
  },
  computed: {
    ...mapState({
      loadingText: (state) => state.textLoadingMaterial,
    }),
    materials() {
      return !this.IsClick ? this.allMaterials : this.searchMaterials
    },
  },
  methods: {
    generos(val) {
      let genero = val.genre ? val.genre : []
      let nombres = []
      genero.forEach((el) => {
        this.listGenders.filter((e) => {
          if (el == e.code) {
            nombres.push(e.name)
          }
        })
      })

      return nombres
    },
    /** Trae la lista de los materiales desde la ruta*/ 
    async getMaterials() {
      this.$localStorage.set('materialId', JSON.stringify(''))
      // 'materials/true'
      // HTTP.get('materials?canned=true')
      // .then(res=>this.allMaterials=res.data.materials)
      // this.loading = true;
      this.loading = true
      try {
        const { data } = await HTTP.get('materials?canned=true')
        if (data.materials && data.materials.length > 0) {
          this.allMaterials = data.materials
        } else {
          this.allMaterials = []
          this.isShowNoResults = true
          this.existMaterial = 'No existen Materiales disponibles'
        }
        this.loading = false
      } catch (err) {
        console.log({ err })
      }
    },
    getDateArrivaldate(material) {
      const { numChapters, infoSupport } = material
      if (numChapters.length > 0) {
        const { infoByChapter } = numChapters[0]
        if (infoByChapter.length > 0) {
          const { arrivalDate } = infoByChapter[0]
          if (arrivalDate !== undefined && arrivalDate !== '')
            return new Date(arrivalDate).toLocaleDateString('en-GB')
          else return ''
        } else {
          return ''
        }
      } else {
        if (infoSupport.length > 0) {
          const { arrivalDate } = infoSupport[0]
          if (arrivalDate !== undefined && arrivalDate !== '') {
            return new Date(arrivalDate).toLocaleDateString('en-GB')
          } else return ''
        } else {
          return ''
        }
      }
    },
    goToNewMaterial() {
      this.$router.push({ name: 'newMaterial2' })
    },
    statusChange(item) {
      const payload = {
        type: 'materials',
        id: item.__id,
        payloadInfo: item,
      }
      this.$store.dispatch('changeStatus', payload)
    },
    /**Se accede a la vista de editar el material y se trae los datos del objeto del material
    * @param {String} event - No definido
    * @param {Object} material - Objeto que trae los datos del material
    */
    editMaterial(event, material) {
      let targetId = event.target.parentElement.parentElement.id
      console.log(material)
      this.$localStorage.set('materialId', JSON.stringify(targetId))
      this.$localStorage.set('materialBag', JSON.stringify(material))
    },
    /**Filtra la lista de materiales depediendo de que opciones se elijan*/
    filterMaterials() {
      let cadenaConexion

      if (
        this.filterSelect == 'startValidity' ||
        (this.filterSelect == 'endValidity' && this.textSearch !== '')
      ) {
        var myDate = this.textSearch
        myDate = myDate.split('/')
        var newDate = myDate[1] + '/' + myDate[0] + '/' + myDate[2]
        var timestamp = new Date(newDate).getTime()
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/${this.filterSelect}/word/${timestamp}`
        )
      } else if (this.filterSelect == '' && this.textSearch !== '') {
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/originalTitle/word/${this.textSearch}`
        )
      } else {
        cadenaConexion = HTTP.get(
          `materials/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`
        )
      }
      cadenaConexion.then((res) => {
        this.existMaterial = 'No encontramos resultados para tu búsqueda'
        this.isShowNoResults = res.data.materials.length == 0 ? true : false
        this.searchMaterials = res.data.materials
        this.IsClick = true
      })
    },
    /**Se limpia los datos llenados en el buscador*/
    cleanSearch() {
      this.filterSelect = ''
      this.isShowNoResults = false
      this.IsClick = false
    },
  },
  beforeDestroy() {
    this.$store.commit(
      'updateTextMaterialEnlatados',
      'Cargando Materiales Enlatados...'
    )
  },
  watch: {
    IsClick() {
      if (this.allMaterials.length == 0) {
        this.isShowNoResults = true
        this.existMaterial = 'No existen Materiales disponibles'
      }
    },
  },
  mounted() {
    HTTP.get(`materials/list/genres`)
      .then((res) => {
        this.listGenders = res.data.listGenders
      })
      .catch((err) => {
        console.log(err)
      })
  },
}
</script>

<style scoped>
.titleSection {
  background: #4a4a4a;
  color: white;
  padding: 10px 10px 10px 35px;
  text-transform: uppercase;
  font-weight: 400;
  margin: 40px auto;
  font-size: 18px;
}
</style>